package Net::Bummskraut::Event;
use strict;

=head2 reg_cb ($eventname1, $cb1, [$eventname2, $cb2, ...])

This method registers a callback C<$cb1> for the event with the
name C<$eventname1>. You can also pass multiple of these eventname => callback
pairs.

To see a documentation of emitted events please take a look at the EVENTS section
below.

=cut

sub reg_cb {
   my ($self, %regs) = @_;

   for my $cmd (keys %regs) {
      my $cb = $regs{$cmd};
      push @{$self->{events}->{$cmd}}, $cb;
   }

   1;
}

sub event {
   my ($self, $ev, @arg) = @_;

   my $nxt = [];
   my @res;

   my $handled;
   for (@{$self->{events}->{lc $ev}}) {
      eval {
         push @res, $_->($self, @arg);
      };
      if ($@) {
         warn "ERROR: EXCEPTION IN CALLBACK: $@\n";
      }
      push @$nxt, $_;
   }

   $self->{events}->{lc $ev} = $nxt;

   @res
}

1;
