package Net::Bummskraut::GUI;
use strict;
use Net::GUI::Event;
use Net::GUI::Collector;
use Net::GUI::Element qw/build_el/;
use Net::GUI;
use Scalar::Util qw/weaken/;

our @ISA = qw/Net::GUI::Event/;

sub new {
   my $this = shift;
   my $class = ref($this) || $this;
   my $self = {@_};
   bless $self, $class;
   $self->{listener} = Net::GUI->new (port => $self->{port});
   my $col = $self->{collector} = Net::GUI::Collector->new;
   $col->attach_to_gui ($self->{listener});
   return $self;
}

sub set_server {
   my ($self, $s) = @_;
   $self->{server} = $s;
}

sub start {
   my ($self) = @_;
   my $l = $self->{listener};

   $l->reg_cb (
      create_gui => sub {
         my ($l, $con, $heap) = @_;
         $self->make_gui ($con, $heap);
      }
   );
}

sub make_gui {
   my ($self, $con, $heap) = @_;

   weaken $heap;
   weaken $con;
   weaken $self;

   my $packet = $con->capture (sub {
      my $w = build_el ([
         window => { name => "main-control" },
         [
            box => { dir => 'v' },
               [button => { label => 'XMPP' }, {
                  clicked =>
                     sub { $self->{xmpp_gui} ? $self->{xmpp_gui}->start ($con, $heap) : () }
               }]
         ],
         { closed => sub { delete $heap->{main_win} } }
      ]);
      $w->show;
      $heap->{main_win} = $w;
   });
   $con->send_commands ($packet);
}
